Index: src/plugins/sip/src/java/net/java/sipmack/media/JmfMediaManager.java
===================================================================
--- src/plugins/sip/src/java/net/java/sipmack/media/JmfMediaManager.java	(revision 11009)
+++ src/plugins/sip/src/java/net/java/sipmack/media/JmfMediaManager.java	(working copy)
@@ -10,26 +10,37 @@
 
 package net.java.sipmack.media;
 
-import org.jivesoftware.sparkimpl.plugin.phone.JMFInit;
-import org.jivesoftware.Spark;
-
-import javax.sdp.*;
-import javax.media.format.AudioFormat;
-import javax.media.format.VideoFormat;
 import java.io.File;
 import java.io.IOException;
+import java.net.Inet6Address;
+import java.net.InetAddress;
+import java.net.InetSocketAddress;
 import java.util.ArrayList;
+import java.util.Hashtable;
 import java.util.List;
 import java.util.Vector;
-import java.util.Hashtable;
-import java.net.InetSocketAddress;
-import java.net.InetAddress;
-import java.net.Inet6Address;
+
+import javax.media.format.AudioFormat;
+import javax.media.format.VideoFormat;
+import javax.sdp.Connection;
+import javax.sdp.Media;
+import javax.sdp.MediaDescription;
+import javax.sdp.Origin;
+import javax.sdp.SdpException;
+import javax.sdp.SdpFactory;
+import javax.sdp.SdpParseException;
+import javax.sdp.SessionDescription;
+import javax.sdp.SessionName;
+import javax.sdp.TimeDescription;
+import javax.sdp.Version;
 
 import net.java.sipmack.common.Log;
+import net.java.sipmack.sip.Call;
 import net.java.sipmack.sip.NetworkAddressManager;
 import net.java.sipmack.sip.SIPConfig;
-import net.java.sipmack.sip.Call;
+
+import org.jivesoftware.sparkimpl.plugin.phone.JMFInit;
+import org.jivesoftware.sparkimpl.settings.local.SettingsManager;
 
 /**
  * JmfMediaManager using JMF based API.
@@ -41,6 +52,7 @@
 public class JmfMediaManager {
 
     private List<AudioFormat> audioFormats = new ArrayList<AudioFormat>();
+    private List<VideoFormat> videoFormats = new ArrayList<VideoFormat>();
     protected SdpFactory sdpFactory = SdpFactory.getInstance();
 
     /**
@@ -48,6 +60,7 @@
      */
     public JmfMediaManager() {
         setupAudioFormats();
+        setupVideoFormats();
     }
 
     /**
@@ -58,12 +71,8 @@
      * @param local
      * @return
      */
-    public AudioMediaSession createMediaSession(final AudioFormat audioFormat, final TransportCandidate remote, final TransportCandidate local) {
-        String locator = "javasound://";
-        if (Spark.isWindows()) {
-            locator = "dsound://";
-        }
-        return new AudioMediaSession(audioFormat, remote, local, locator);
+    public AudioMediaSession createMediaSession(final AudioFormat audioFormat, final TransportCandidate remote, final TransportCandidate local) {    	
+        return new AudioMediaSession(audioFormat, remote, local, SettingsManager.getLocalPreferences().getAudioDevice());
     }
 
     /**
@@ -73,9 +82,18 @@
         audioFormats.add(new AudioFormat(AudioFormat.GSM_RTP));
         audioFormats.add(new AudioFormat(AudioFormat.G723_RTP));
         audioFormats.add(new AudioFormat(AudioFormat.ULAW_RTP));
+        audioFormats.add(new AudioFormat(AudioFormat.ALAW));
     }
 
     /**
+     * Setup API supported VideoFormats
+     */
+    private void setupVideoFormats() {
+    	videoFormats.add(new VideoFormat(VideoFormat.H261_RTP));
+    	videoFormats.add(new VideoFormat(VideoFormat.H263_RTP));
+    }
+    
+    /**
      * Return all supported Payloads for this Manager
      *
      * @return The Payload List
@@ -83,7 +101,179 @@
     public List<AudioFormat> getAudioFormats() {
         return audioFormats;
     }
+    
+    /**
+     * Return all supported Payloads for this Manager
+     *
+     * @return The Payload List
+     */
+    public List<VideoFormat> getVideoFormats() {
+        return videoFormats;
+    }
+
+    /**
+     * Creates a new VideoMedia Session for a given sdpData
+     *
+     * @param sdpData
+     * @return
+     * @throws MediaException
+     */
+    public VideoMediaSession createVideoMediaSession(String sdpData, int localPort) throws MediaException {
+        SessionDescription sessionDescription = null;
+        if (sdpData == null) {
+            throw new MediaException("The SDP data was null! Cannot open "
+                    + "a stream withour an SDP Description!");
+        }
+        try {
+            sessionDescription = sdpFactory
+                    .createSessionDescription(sdpData);
+
+        }
+        catch (SdpParseException ex) {
+
+            throw new MediaException("Incorrect SDP data!", ex);
+        }
+        Vector mediaDescriptions;
+        try {
+            mediaDescriptions = sessionDescription
+                    .getMediaDescriptions(true);
+        }
+        catch (SdpException ex) {
+            throw new MediaException(
+                    "Failed to extract media descriptions from provided session description!",
+                    ex);
+        }
+        Connection sessionConnection = sessionDescription.getConnection();
+        String sessionRemoteAddress = null;
+        if (sessionConnection != null) {
+            try {
+                sessionRemoteAddress = sessionConnection.getAddress();
+            }
+            catch (SdpParseException ex) {
+                throw new MediaException(
+                        "Failed to extract the connection address parameter"
+                                + "from privided session description", ex);
+            }
+        }
+        int mediaPort = -1;
+        boolean atLeastOneTransmitterStarted = false;
+        ArrayList mediaTypes = new ArrayList();
+        ArrayList<String> remoteAddresses = new ArrayList<String>();
+        // A hashtable that indicates what addresses are different media
+        // types
+        // coming from.
+        Hashtable<String, String> remoteTransmisionDetails = new Hashtable<String, String>();
+        // by default everything is supposed to be coming from the address
+        // specified in the session (global) connection parameter so store
+        // this address for now.
+        if (sessionRemoteAddress != null) {
+            remoteTransmisionDetails.put("audio", sessionRemoteAddress);
+            remoteTransmisionDetails.put("video", sessionRemoteAddress);
+        }
+        ArrayList<Integer> ports = new ArrayList<Integer>();
+        ArrayList formatSets = new ArrayList();
+        ArrayList<String> contents = new ArrayList<String>();
+        ArrayList<Integer> localPorts = new ArrayList<Integer>();
+        for (int i = 0; i < mediaDescriptions.size(); i++) {
+            MediaDescription mediaDescription = (MediaDescription) mediaDescriptions
+                    .get(i);
+            Media media = mediaDescription.getMedia();
+            // Media Type
+            String mediaType = null;
+            try {
+                mediaType = media.getMediaType();
+            }
+            catch (SdpParseException ex) {
+                continue;
+            }
+            // Find ports
+            try {
+                mediaPort = media.getMediaPort();
+            }
+            catch (SdpParseException ex) {
+                throw (new MediaException(
+                        "Failed to extract port for media type ["
+                                + mediaType + "]. Ignoring description!",
+                        ex));
+            }
+            // Find formats
+            Vector sdpFormats = null;
+            try {
+                sdpFormats = media.getMediaFormats(true);
+            }
+            catch (SdpParseException ex) {
+                throw (new MediaException(
+                        "Failed to extract media formats for media type ["
+                                + mediaType + "]. Ignoring description!",
+                        ex));
+
+            }
+
+            Connection mediaConnection = mediaDescription.getConnection();
+            String mediaRemoteAddress = null;
+            if (mediaConnection == null) {
+                if (sessionConnection == null) {
+                    throw new MediaException(
+                            "A connection parameter was not present in provided session/media description");
+                } else {
+                    mediaRemoteAddress = sessionRemoteAddress;
+                }
+            } else {
+                try {
+                    mediaRemoteAddress = mediaConnection.getAddress();
+                }
+                catch (SdpParseException ex) {
+                    throw new MediaException(
+                            "Failed to extract the connection address parameter"
+                                    + "from privided media description", ex);
+                }
+            }
+
+            // update the remote address for the current media type in case
+            // it is specific for this media (i.e. differs from the main
+            // connection address)
+            remoteTransmisionDetails.put(mediaType, mediaRemoteAddress);
+            // START TRANSMISSION
+            try {
+                remoteAddresses.add(mediaRemoteAddress);
+                ports.add(new Integer(mediaPort));
+                contents.add(mediaType);
+
+                // Selecting local ports for NAT
+
+                if (mediaType.trim().equals("video"))
+                    localPorts.add(Integer.valueOf(22444));
+                else if (mediaType.trim().equals("audio"))
+                    localPorts.add(Integer.valueOf(localPort));
+                else
+                    localPorts.add(Integer.valueOf(mediaPort));
+
+                formatSets.add(extractTransmittableJmfFormats(sdpFormats));
+            }
+            catch (MediaException ex) {
+                Log.error("StartMedia", ex);
+                throw (new MediaException(
+                        "Could not start a transmitter for media type ["
+                                + mediaType + "]\nIgnoring media ["
+                                + mediaType + "]!", ex));
+            }
+            atLeastOneTransmitterStarted = true;
+        }
+        if (atLeastOneTransmitterStarted) {
+
+            TransportCandidate.Fixed remote = new TransportCandidate.Fixed(remoteAddresses.get(0).toString(), (Integer) ports.get(0));
+            TransportCandidate.Fixed local = new TransportCandidate.Fixed(NetworkAddressManager.getLocalHost().getHostAddress(), localPort);
 
+            // TODO : FORCED TO JPEG_RTP -> deteced format
+            // VideoFormat videoFormat = new VideoFormat((String) (((ArrayList) formatSets.get(0)).get(0)));
+            VideoFormat videoFormat = new VideoFormat(VideoFormat.JPEG_RTP);         
+            VideoMediaSession videoMediaSession = new VideoMediaSession(videoFormat, remote, local, SettingsManager.getLocalPreferences().getVideoDevice());;
+
+            return videoMediaSession;
+        }
+        return null;
+    }
+    
     /**
      * Creates a new AudioMedia Session for a given sdpData
      *
@@ -92,10 +282,6 @@
      * @throws MediaException
      */
     public AudioMediaSession createAudioMediaSession(String sdpData, int localPort) throws MediaException {
-        String locator = "javasound://";
-        if (Spark.isWindows()) {
-            locator = "dsound://";
-        }
         SessionDescription sessionDescription = null;
         if (sdpData == null) {
             throw new MediaException("The SDP data was null! Cannot open "
@@ -135,11 +321,11 @@
         int mediaPort = -1;
         boolean atLeastOneTransmitterStarted = false;
         ArrayList mediaTypes = new ArrayList();
-        ArrayList remoteAddresses = new ArrayList();
+        ArrayList<String> remoteAddresses = new ArrayList<String>();
         // A hashtable that indicates what addresses are different media
         // types
         // coming from.
-        Hashtable remoteTransmisionDetails = new Hashtable();
+        Hashtable<String, String> remoteTransmisionDetails = new Hashtable<String, String>();
         // by default everything is supposed to be coming from the address
         // specified in the session (global) connection parameter so store
         // this address for now.
@@ -147,10 +333,10 @@
             remoteTransmisionDetails.put("audio", sessionRemoteAddress);
             remoteTransmisionDetails.put("video", sessionRemoteAddress);
         }
-        ArrayList ports = new ArrayList();
+        ArrayList<Integer> ports = new ArrayList<Integer>();
         ArrayList formatSets = new ArrayList();
-        ArrayList contents = new ArrayList();
-        ArrayList localPorts = new ArrayList();
+        ArrayList<String> contents = new ArrayList<String>();
+        ArrayList<Integer> localPorts = new ArrayList<Integer>();
         for (int i = 0; i < mediaDescriptions.size(); i++) {
             MediaDescription mediaDescription = (MediaDescription) mediaDescriptions
                     .get(i);
@@ -219,11 +405,11 @@
                 // Selecting local ports for NAT
 
                 if (mediaType.trim().equals("video"))
-                    localPorts.add(new Integer(22444));
+                    localPorts.add(Integer.valueOf(22445));
                 else if (mediaType.trim().equals("audio"))
-                    localPorts.add(new Integer(localPort));
+                    localPorts.add(Integer.valueOf(localPort));
                 else
-                    localPorts.add(new Integer(mediaPort));
+                    localPorts.add(Integer.valueOf(mediaPort));
 
                 formatSets
                         .add(extractTransmittableJmfFormats(sdpFormats));
@@ -244,7 +430,7 @@
 
             AudioFormat audioFormat = new AudioFormat((String) (((ArrayList) formatSets.get(0)).get(0)));
 
-            AudioMediaSession audioMediaSession = new AudioMediaSession(audioFormat, remote, local, locator);
+            AudioMediaSession audioMediaSession = new AudioMediaSession(audioFormat, remote, local, SettingsManager.getLocalPreferences().getAudioDevice());
 
             return audioMediaSession;
         }
@@ -275,9 +461,8 @@
      */
     protected ArrayList<String> extractTransmittableJmfFormats(Vector sdpFormats)
             throws MediaException {
-        ArrayList jmfFormats = new ArrayList();
+        ArrayList<String> jmfFormats = new ArrayList<String>();
         for (int i = 0; i < sdpFormats.size(); i++) {
-            int sdpFormat = -1;
             String jmfFormat = AudioFormatUtils.findCorrespondingJmfFormat(sdpFormats
                     .elementAt(i).toString());
             if (jmfFormat != null) {
@@ -330,33 +515,39 @@
                     publicIpAddress.getHostAddress());
             // "t=0 0"
             TimeDescription t = sdpFactory.createTimeDescription();
-            Vector timeDescs = new Vector();
+            Vector<TimeDescription> timeDescs = new Vector<TimeDescription>();
             timeDescs.add(t);
             // --------Audio media description
             // make sure preferred formats come first
-            String[] formats = new String[getAudioFormats().size()];
+            String[] aformats = new String[getAudioFormats().size()];
 
             int i = 0;
             for (AudioFormat audioFormat : getAudioFormats()) {
-                formats[i++] = AudioFormatUtils.findCorrespondingSdpFormat(audioFormat.getEncoding());
+                aformats[i++] = AudioFormatUtils.findCorrespondingSdpFormat(audioFormat.getEncoding());
             }
 
             MediaDescription am = sdpFactory.createMediaDescription(
                     "audio", publicAudioAddress.getPort(), 1, "RTP/AVP",
-                    formats);
-            //if (!isAudioTransmissionSupported()) {
-            //am.setAttribute("recvonly", null);
-            // --------Video media description
-            //} else {
+                    aformats);
             am.setAttribute("sendrecv", null);
-            //}
-
+            
             am.setAttribute("rtmap:101", "telephone-event/"
                     + publicAudioAddress.getPort());
 
-            Vector mediaDescs = new Vector();
+            i = 0;
+            String[] vformats = new String[getVideoFormats().size()];
+            for (VideoFormat videoFormat : getVideoFormats()) {
+                vformats[i++] = AudioFormatUtils.findCorrespondingSdpFormat(videoFormat.getEncoding());
+            }
+            
+            MediaDescription vam = sdpFactory.createMediaDescription(
+                    "video", publicVideoAddress.getPort(), 1, "RTP/AVP",
+                    vformats);
+            
+            Vector<MediaDescription> mediaDescs = new Vector<MediaDescription>();
 
             mediaDescs.add(am);
+            mediaDescs.add(vam);
 
             sessDescr.setVersion(v);
             sessDescr.setOrigin(o);
@@ -400,7 +591,7 @@
             Origin o = sdpFactory.createOrigin(SIPConfig.getUserName()
                     .replace(' ', '_'), 20109217, 2, "IN", addrType,
                     publicIpAddress.getHostAddress());
-            SessionName s = sdpFactory.createSessionName("<SIPmack>");
+            SessionName s = sdpFactory.createSessionName("<SparkPhone>");
             Connection c = sdpFactory.createConnection("IN", addrType,
                     publicIpAddress.getHostAddress());
             TimeDescription t = sdpFactory.createTimeDescription();
Index: src/plugins/sip/src/java/net/java/sipmack/softphone/listeners/RegisterEvent.java
===================================================================
--- src/plugins/sip/src/java/net/java/sipmack/softphone/listeners/RegisterEvent.java	(revision 11009)
+++ src/plugins/sip/src/java/net/java/sipmack/softphone/listeners/RegisterEvent.java	(working copy)
@@ -16,7 +16,9 @@
 
 public class RegisterEvent extends EventObject {
 
-    private SipRegisterStatus status = SipRegisterStatus.Unregistered;
+	private static final long serialVersionUID = 6673006341746488777L;
+
+	private SipRegisterStatus status = SipRegisterStatus.Unregistered;
 
     private String reason = "";
 
Index: src/plugins/sip/src/java/net/java/sipmack/sip/event/CallEvent.java
===================================================================
--- src/plugins/sip/src/java/net/java/sipmack/sip/event/CallEvent.java	(revision 11009)
+++ src/plugins/sip/src/java/net/java/sipmack/sip/event/CallEvent.java	(working copy)
@@ -1,92 +1,23 @@
-/* ====================================================================
- * The Apache Software License, Version 1.1
- *
- * Copyright (c) 2000 The Apache Software Foundation.  All rights
- * reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- *
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- *
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in
- *    the documentation and/or other materials provided with the
- *    distribution.
- *
- * 3. The end-user documentation included with the redistribution,
- *    if any, must include the following acknowledgment:
- *       "This product includes software developed by the
- *        Apache Software Foundation (http://www.apache.org/)."
- *    Alternately, this acknowledgment may appear in the software itself,
- *    if and wherever such third-party acknowledgments normally appear.
- *
- * 4. The names "Apache" and "Apache Software Foundation" must
- *    not be used to endorse or promote products derived from this
- *    software without prior written permission. For written
- *    permission, please contact apache@apache.org.
- *
- * 5. Products derived from this software may not be called "Apache",
- *    nor may "Apache" appear in their name, without prior written
- *    permission of the Apache Software Foundation.
- *
- * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
- * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
- * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
- * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
- * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
- * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
- * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
- * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
- * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
- * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
- * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
- * SUCH DAMAGE.
- * ====================================================================
+/**
+ * $Revision: $
+ * $Date: $
  *
- * This software consists of voluntary contributions made by many
- * individuals on behalf of the Apache Software Foundation.  For more
- * information on the Apache Software Foundation, please see
- * <http://www.apache.org/>.
+ * Copyright (C) 2009 Jive Software. All rights reserved.
  *
- * Portions of this software are based upon public domain software
- * originally written at the National Center for Supercomputing Applications,
- * University of Illinois, Urbana-Champaign.
+ * This software is published under the terms of the GNU Lesser Public License (LGPL),
+ * a copy of which is included in this distribution.
  */
-
 package net.java.sipmack.sip.event;
 
 import net.java.sipmack.sip.Call;
 
 import java.util.EventObject;
 
-/**
- * <p/>
- * Title: SIP COMMUNICATOR
- * </p>
- * <p/>
- * Description:JAIN-SIP Audio/Video phone application
- * </p>
- * <p/>
- * Copyright: Copyright (c) 2003
- * </p>
- * <p/>
- * Organisation: LSIIT laboratory (http://lsiit.u-strasbg.fr)
- * </p>
- * <p/>
- * Network Research Team (http://www-r2.u-strasbg.fr))
- * </p>
- * <p/>
- * Louis Pasteur University - Strasbourg - France
- * </p>
- *
- * @author Emil Ivov (http://www.emcho.com)
- * @version 1.1
- */
+
 public class CallEvent extends EventObject {
-    public CallEvent(Object source) {
+	private static final long serialVersionUID = -7791513047352316593L;
+
+	public CallEvent(Object source) {
         super(source);
     }
 
Index: src/plugins/sip/src/java/net/java/sipmack/sip/security/CredentialsCache.java
===================================================================
--- src/plugins/sip/src/java/net/java/sipmack/sip/security/CredentialsCache.java	(revision 11009)
+++ src/plugins/sip/src/java/net/java/sipmack/sip/security/CredentialsCache.java	(working copy)
@@ -1,61 +1,12 @@
-/* ====================================================================
- * The Apache Software License, Version 1.1
- *
- * Copyright (c) 2000 The Apache Software Foundation.  All rights
- * reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- *
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- *
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in
- *    the documentation and/or other materials provided with the
- *    distribution.
- *
- * 3. The end-user documentation included with the redistribution,
- *    if any, must include the following acknowledgment:
- *       "This product includes software developed by the
- *        Apache Software Foundation (http://www.apache.org/)."
- *    Alternately, this acknowledgment may appear in the software itself,
- *    if and wherever such third-party acknowledgments normally appear.
- *
- * 4. The names "Apache" and "Apache Software Foundation" must
- *    not be used to endorse or promote products derived from this
- *    software without prior written permission. For written
- *    permission, please contact apache@apache.org.
- *
- * 5. Products derived from this software may not be called "Apache",
- *    nor may "Apache" appear in their name, without prior written
- *    permission of the Apache Software Foundation.
- *
- * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
- * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
- * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
- * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
- * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
- * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
- * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
- * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
- * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
- * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
- * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
- * SUCH DAMAGE.
- * ====================================================================
+/**
+ * $Revision: $
+ * $Date: $
  *
- * This software consists of voluntary contributions made by many
- * individuals on behalf of the Apache Software Foundation.  For more
- * information on the Apache Software Foundation, please see
- * <http://www.apache.org/>.
+ * Copyright (C) 2009 Jive Software. All rights reserved.
  *
- * Portions of this software are based upon public domain software
- * originally written at the National Center for Supercomputing Applications,
- * University of Illinois, Urbana-Champaign.
+ * This software is published under the terms of the GNU Lesser Public License (LGPL),
+ * a copy of which is included in this distribution.
  */
-
 package net.java.sipmack.sip.security;
 
 import java.util.Hashtable;
@@ -73,7 +24,7 @@
 
 class CredentialsCache {
     // Contains call->realms mappings
-    private Hashtable authenticatedRealms = new Hashtable();
+    private Hashtable<String, CredentialsCacheEntry> authenticatedRealms = new Hashtable<String, CredentialsCacheEntry>();
 
     /**
      * Cache credentials for the specified call and realm
Index: src/plugins/sip/src/java/net/java/sipmack/sip/event/MessageEvent.java
===================================================================
--- src/plugins/sip/src/java/net/java/sipmack/sip/event/MessageEvent.java	(revision 11009)
+++ src/plugins/sip/src/java/net/java/sipmack/sip/event/MessageEvent.java	(working copy)
@@ -1,61 +1,12 @@
-/* ====================================================================
- * The Apache Software License, Version 1.1
- *
- * Copyright (c) 2000 The Apache Software Foundation.  All rights
- * reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- *
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- *
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in
- *    the documentation and/or other materials provided with the
- *    distribution.
- *
- * 3. The end-user documentation included with the redistribution,
- *    if any, must include the following acknowledgment:
- *       "This product includes software developed by the
- *        Apache Software Foundation (http://www.apache.org/)."
- *    Alternately, this acknowledgment may appear in the software itself,
- *    if and wherever such third-party acknowledgments normally appear.
- *
- * 4. The names "Apache" and "Apache Software Foundation" must
- *    not be used to endorse or promote products derived from this
- *    software without prior written permission. For written
- *    permission, please contact apache@apache.org.
- *
- * 5. Products derived from this software may not be called "Apache",
- *    nor may "Apache" appear in their name, without prior written
- *    permission of the Apache Software Foundation.
- *
- * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
- * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
- * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
- * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
- * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
- * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
- * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
- * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
- * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
- * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
- * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
- * SUCH DAMAGE.
- * ====================================================================
+/**
+ * $Revision: $
+ * $Date: $
  *
- * This software consists of voluntary contributions made by many
- * individuals on behalf of the Apache Software Foundation.  For more
- * information on the Apache Software Foundation, please see
- * <http://www.apache.org/>.
+ * Copyright (C) 2009 Jive Software. All rights reserved.
  *
- * Portions of this software are based upon public domain software
- * originally written at the National Center for Supercomputing Applications,
- * University of Illinois, Urbana-Champaign.
+ * This software is published under the terms of the GNU Lesser Public License (LGPL),
+ * a copy of which is included in this distribution.
  */
-
 package net.java.sipmack.sip.event;
 
 import javax.sip.header.FromHeader;
@@ -63,27 +14,10 @@
 
 import java.util.EventObject;
 
-/**
- * <p/>
- * Title: SIP COMMUNICATOR-1.1
- * </p>
- * <p/>
- * Description: JAIN-SIP-1.1 Audio/Video Phone Application
- * </p>
- * <p/>
- * Copyright: Copyright (c) 2003
- * </p>
- * <p/>
- * Company: Organisation: LSIIT Laboratory (http://lsiit.u-strasbg.fr) \nNetwork
- * Research Team (http://www-r2.u-strasbg.fr))\nLouis Pasteur University -
- * Strasbourg - France
- * </p>
- *
- * @author Emil Ivov
- * @version 1.1
- */
 public class MessageEvent extends EventObject {
-    public MessageEvent(Request source) {
+	private static final long serialVersionUID = 5165120956285347269L;
+
+	public MessageEvent(Request source) {
         super(source);
     }
 
